'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeComponent = exports.updateComponent = exports.setComponent = exports.addComponent = exports.REMOVE_COMPONENT = exports.UPDATE_COMPONENT = exports.SET_COMPONENT = exports.ADD_COMPONENT = undefined;

var _cuid = require('cuid');

var _cuid2 = _interopRequireDefault(_cuid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ADD_COMPONENT = exports.ADD_COMPONENT = '@@relocation/ADD_COMPONENT';
var SET_COMPONENT = exports.SET_COMPONENT = '@@relocation/SET_COMPONENT';
var UPDATE_COMPONENT = exports.UPDATE_COMPONENT = '@@relocation/UPDATE_COMPONENT';
var REMOVE_COMPONENT = exports.REMOVE_COMPONENT = '@@relocation/REMOVE_COMPONENT';

var addComponent = exports.addComponent = function addComponent(type, props, meta) {
  return {
    type: ADD_COMPONENT,
    payload: { id: (0, _cuid2.default)(), type: type, props: props, meta: meta }
  };
};

var setComponent = exports.setComponent = function setComponent(type) {
  var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : type;
  var props = arguments[2];
  var meta = arguments[3];
  return {
    type: SET_COMPONENT,
    payload: { id: id, type: type, props: props, meta: meta }
  };
};

var updateComponent = exports.updateComponent = function updateComponent(id, props, meta) {
  return {
    type: UPDATE_COMPONENT,
    payload: { id: id, props: props, meta: meta }
  };
};

var removeComponent = exports.removeComponent = function removeComponent(id) {
  return {
    type: REMOVE_COMPONENT,
    payload: { id: id }
  };
};
//# sourceMappingURL=action.js.map