'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactRedux = require('react-redux');

var _selector = require('./selector');

var _action = require('./action');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getFinalComponents = function getFinalComponents(state, props) {
  var initial = (0, _selector.getComponents)(state, props);
  var exists = function exists(component) {
    return typeof props.components[component.type] === 'function';
  };
  var shouldMount = props.componentShouldMount || function () {
    return true;
  };
  return initial.filter(function (component) {
    return exists(component) && shouldMount(state, props, component);
  });
};

/**
 * Create a higher-order wrapper which provides an array of components to render
 * to its wrapped instance.
 *
 * @param {Object|Function} rawRenderMap An object with component type/render
 * function key value pairs or a function returning such an object.
 * @param {Object} defaultProps An object or a function returing such an
 * object.
 * @returns {Function} Higher-order component wrapper.
 */

exports.default = function () {
  return function (WrappedComponent) {
    var Connect = function (_Component) {
      _inherits(Connect, _Component);

      function Connect() {
        _classCallCheck(this, Connect);

        return _possibleConstructorReturn(this, (Connect.__proto__ || Object.getPrototypeOf(Connect)).apply(this, arguments));
      }

      _createClass(Connect, [{
        key: 'render',
        value: function render() {
          var _props = this.props,
              ___relocationState___ = _props.___relocationState___,
              ___relocationDispatch___ = _props.___relocationDispatch___,
              childProps = _objectWithoutProperties(_props, ['___relocationState___', '___relocationDispatch___']);

          var components = ___relocationState___.components,
              instances = ___relocationState___.instances;
          var removeComponent = ___relocationDispatch___.removeComponent,
              updateComponent = ___relocationDispatch___.updateComponent;


          var assign = function assign(component) {
            var result = _extends({}, component, {
              containerProps: childProps,
              render: components[component.type],
              update: function update() {
                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = arguments[_key];
                }

                return updateComponent.apply(undefined, [component.id].concat(args));
              },
              remove: function remove() {
                for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                  args[_key2] = arguments[_key2];
                }

                return removeComponent.apply(undefined, [component.id].concat(args));
              }
            });

            return result;
          };

          var currentComponents = instances.map(assign);

          var mergedProps = _extends({}, childProps, {
            components: currentComponents
          });

          return (0, _react.createElement)(WrappedComponent, mergedProps);
        }
      }]);

      return Connect;
    }(_react.Component);

    Connect.propTypes = {
      ___relocationDispatch___: _propTypes2.default.shape({
        removeComponent: _propTypes2.default.func.isRequired,
        updateComponent: _propTypes2.default.func.isRequired
      }),
      ___relocationState___: _propTypes2.default.shape({
        components: _util.componentsShape.isRequired,
        instances: _util.instancesShape.isRequired
      }).isRequired
    };


    Connect.displayName = 'Relocation(' + (0, _util.getDisplayName)(WrappedComponent) + ')';

    var mapState = function mapState(state, props) {
      return {
        // Put everything in a ___relocationState___ namespace to avoid possible
        // conflict with existing props.
        ___relocationState___: {
          instances: getFinalComponents(state, props),
          components: props.components
        }
      };
    };

    var mapDispatch = function mapDispatch(dispatch) {
      return {
        // Put everything in a ___relocationDispatch___ namespace to avoid
        // possible conflict with existing props.
        ___relocationDispatch___: {
          removeComponent: function removeComponent(id) {
            return dispatch((0, _action.removeComponent)(id));
          },
          updateComponent: function updateComponent(id, props) {
            return dispatch((0, _action.updateComponent)(id, props));
          }
        }
      };
    };

    return (0, _reactRedux.connect)(mapState, mapDispatch)((0, _hoistNonReactStatics2.default)(Connect, WrappedComponent));
  };
};
//# sourceMappingURL=connect.js.map