'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.instancesShape = exports.instanceShape = exports.componentsShape = exports.componentShape = exports.getDisplayName = undefined;

var _react = require('react');

var getDisplayName = exports.getDisplayName = function getDisplayName(C) {
  return C.displayName || C.name || 'Component';
};

var componentShape = exports.componentShape = _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]);

var componentsShape = exports.componentsShape = _react.PropTypes.objectOf(componentShape);

var instanceShape = exports.instanceShape = _react.PropTypes.shape({
  id: _react.PropTypes.string.isRequired,
  type: _react.PropTypes.string.isRequired,
  scope: _react.PropTypes.string,
  props: _react.PropTypes.object,
  remove: _react.PropTypes.func,
  update: _react.PropTypes.func,
  render: componentShape
});

var instancesShape = exports.instancesShape = _react.PropTypes.arrayOf(instanceShape);
//# sourceMappingURL=util.js.map